<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

class jvideodirectControllerCategory extends jvideodirectController
{
	function __construct() {
		parent::__construct();
	}

	function addCategory() {
		require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');	
		JRequest::checkToken() or jexit( 'Request Forbidden' );				
			$cat->name = JRequest::getVar( 'cat_name', '' );
			$cat->description = JRequest::getVar( 'cat_desc', '' );
			if(!$cat->name) { $msg= JText::_('DV_ADM_ERROR_CATNAME'); $msgtype = "error";}
			if(!$cat->description) { $msg= JText::_('DV_ADM_ERROR_CATDESC'); $msgtype = "error";}
			if (($cat->name) && ($cat->description)) {	
				$user=&JFactory::getUser();
				$cat->user_id = $user->id;
				$createdate =& JFactory::getDate(time());;
				$cat->date_added = $createdate->toFormat();
				$model =& $this->getModel( 'Category' );
				$data =& $model->saveCData($cat, 'dv_categories');
				if($data) {
					$msg = JText::_('DV_ADM_C_SUCC_ADD');
					$msgtype = '';
				} else {
					$msg = JText::_('DV_ADM_ERROR_CATSAVE');
					$msgtype = 'error';				
				}
			}
			$this->setRedirect('index.php?option=com_jvideodirect&view=category', $msg, $msgtype);		
	}
	
	function cancel() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect( 'index.php?option=com_jvideodirect', $msg );
	}

	function deleteCat() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());
		$db =& JFactory::getDBO();
		if(count($cid)) {
			$flag = false;
			$cids = implode( ',', $cid );
			$query = "SELECT * FROM #__dv_videos WHERE catid IN ( $cids )";
			$db->setQuery( $query );
			$v = $db->loadObjectList();
			if (count($v) < 1) {
				$flag = true;
			} else {
				$msgtype = 'error';	
				$msg = JText::_('DV_ADM_ERROR_CATDEL1');	
			}
			if ($flag == true) {
				$query = "DELETE FROM #__dv_categories WHERE id IN ( $cids )";
				$db->setQuery( $query );	
				if (!$db->query()){
					$msg = JText::_('DV_ADM_ERROR_CATDEL');
					$msgtype = 'error';	
				} else {
					$msg = JText::_('DV_ADM_C_SUCC_DEL');
					$msgtype = '';			
				}
			}
		}	
		$this->setRedirect('index.php?option=com_jvideodirect&view=category', $msg, $msgtype);	
	}

	function saveEdit() {
//		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');			
		$id = JRequest::getVar( 'id', '' );		
		$db =& JFactory::getDBO();
		$cat->name = viewTools::cleantext(JRequest::getVar( 'cat_name', '' ),false);
		$cat->description = viewTools::cleantext(JRequest::getVar( 'cat_desc', '' ),false);
		$cat->tags = $db->getEscaped(viewTools::cleantext(JRequest::getVar( 'cat_tags', '' ),false));
		$cat->tags = helperTools::tagStd($cat->tags);	
		
		$srcphoto = JRequest::getVar( 'cat_image', null, 'files', 'array');	
		$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'pics'.DS.'categories';		
		$model =& $this->getModel( 'Category' );		
		if(!$cat->name) { $msg= JText::_('DV_ADM_ERROR_CATNAME'); $msgtype = "error";}
		if(!$cat->description) { $msg= JText::_('DV_ADM_ERROR_CATDESC'); $msgtype = "error";}
		if ($srcphoto['error'] == 0) {
			$fileExt = strtolower(jFile::getExt ($srcphoto['name']));
			if (($fileExt == 'png')||($fileExt == 'jpg')||($fileExt == 'gif')) {
				$name =& $model->processImage($srcphoto);
				if ($name[1] == true) { 	
					if (JFile::exists($base.DS.$name[0].'.png')) {
					$imageok = true; $cat->image = $name[0];} else {$imageok = false;} 	
				} else {$msg = JText::_('Image upload error'); $msgtype = 'error';JError::raiseWarning( 500, $msg);}
			} else {$msg = JText::_('Only gif, png, jpg format is supported'); $msgtype = 'error';JError::raiseWarning( 500, $msg);}
		}		
		if (($cat->name) && ($cat->description)) {		
			$data =& $model->saveCData($cat, 'dv_categories', $id);
			if($data) {
				$msg = JText::_('DV_ADM_C_SUCC_EDIT');
				$msgtype = '';
			} else {
				$msg = JText::_('DV_ADM_ERROR_CATSAVE');
				$msgtype = 'error';				
			}
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=category', $msg, $msgtype);	
	}

	function publish() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}
		$model = $this->getModel('category');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=category');
	}


	function unpublish() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}
		$model = $this->getModel('category');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=category');
	}

	function feature() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to feature' ) );
		}
		$model = $this->getModel('category');
		if(!$model->feature($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=category');
	}


	function unfeature() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unfeature' ) );
		}
		$model = $this->getModel('category');
		if(!$model->feature($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$this->setRedirect('index.php?option=com_jvideodirect&view=category');
	}

	function orderup() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$model = $this->getModel('category');
		$model->move(-1);
		$this->setRedirect('index.php?option=com_jvideodirect&view=category');
	}

	function orderdown() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );
		$model = $this->getModel('category');
		$model->move(1);
		$this->setRedirect('index.php?option=com_jvideodirect&view=category');
	}

	function saveorder() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );

		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );	
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);
		$model = $this->getModel('category');
		$model->saveorder($cid, $order);
		$msg = JText::_( 'New ordering saved' );
		$this->setRedirect('index.php?option=com_jvideodirect&view=category', $msg);
	}	
}
?>
