<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

class jvideodirectControllerConfig extends jvideodirectController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'applyConfig', 'saveConfig' );
	}

	function saveConfig() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		jimport( 'joomla.filesystem.archive' );		
		$sysMax = @ini_get( 'upload_max_filesize' );
		$systemMax = substr($sysMax,0,strlen($sysMax)-1);
		if (strtolower(substr($sysMax,-1)) == 'k'){
			$systemMax = $systemMax / 1000;
		}
		$rows = JRequest::get('post');
		$config = new JConfig;
		jimport('joomla.client.helper');
		if (($config->ftp_enable == true) && (JClientHelper::setCredentialsFromRequest('ftp') == true)) {
				JClientHelper::setCredentials('ftp',$rows['ftpusername'], $rows['ftppassword']);
		}			
		$model =& $this->getModel( 'Config' );
		$players =& $model->getPlayers();
		for($i=0;$i<count($players);$i++) {
			$j= $i+1;
			if ($rows['flvplayer'] == $j) { 
				$flvplayer = $players[$i]->data;
				break;
			} else {$flvplayer = 'flowplayer';}
		}
		$rows['flvplayer'] = $flvplayer;
		if ($rows['fetchlinkonly'] == true) { 
			$rows['fetchType'] = '1';
			$rows['pathToPhp'] = '';
			$rows['pathToWget'] = '';
		}
		$themes = JFolder::folders(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'themes');
		$themeArray = $rows['theme'] - 1;
		$rows['theme'] = $themes[$themeArray];		
		if ($rows['ubruploadpl'] == '') {$rows['ubruploadpl'] = '/cgi-bin/ubr_upload.pl';}
		if ($rows['maxFileSize'] == '') {$rows['maxFileSize'] = $systemMax;}
		$colorRef = array(1 => 'blue','green','orange','purple','pink','red','yellow'); 
		$rows['barColorPl'] = $colorRef[ $rows['barColorPl'] ];
		$rows['upTitleColor'] = $colorRef[ $rows['upTitleColor'] ];
		$rows['maxFileSizeByte'] = $rows['maxFileSize'] * 1024 * 1024;
		if ($rows['commentSys']) {
			switch($rows['commentSys']) {
				case '1':
					$installed =& $model->checkcomponent('jomcomment');
					if($installed == false) { 
						$rows['commentSys'] = 0;
						$message = JText::_('JomComment is not installed');
						JError::raiseWarning( 500, $message);
					}
				break;
			}
		}
		if ($rows['communitySys']) {
			switch($rows['communitySys']) {
				case '1':
					$installed =& $model->checkcomponent('community');
					if ($installed == false) { 
						$rows['communitySys'] = 0;
						$message = JText::_('JomSocial is not installed');
						JError::raiseWarning( 500, $message);
					}
				break;
				case '2':
					$installed =& $model->checkcomponent('comprofiler');
					if ($installed == false) { 
						$rows['communitySys'] = 0;
						$message = JText::_('Community Builder is not installed');
						JError::raiseWarning( 500, $message);
					}
				break;				
			}
		}		
		$model =& $this->getModel( 'Config' );
		$data =& $model->filterConfig($rows);	
		$store =& $model->storeConfig($data);
		if ($store) {
			$write =& $model->createConfigFile();
			if (!$write) {
				$this->setRedirect('index.php?option=com_jvideodirect&view=config'.$page, JText::_('DV_ADM_ERROR_FILE_NO_CREATED'), 'error');
				$controller = new jvideodirectController();
				$controller->redirect();
			}
		}
		$task = JRequest::getCmd( 'task', null ); 
		$page = JRequest::getVar( 'page', null );
		$session =& JFactory::getSession();
		if (!empty($page)) {
			$session->clear('jvdconfigPage','jvideodirect');
			$session->set('jvdconfigPage', $page, 'jvideodirect');	
		} else {
			$page = $session->get('jvdconfigPage', '', 'jvideodirect');
		}		
		if ($page != null) {$page = '&page='.$page;}
		switch ($task)
		{
			case 'applyConfig':
				$this->setRedirect('index.php?option=com_jvideodirect&view=config', JText::_('DV_ADM_CONFIG_SAVE'));
				break;
	
			case 'saveConfig':
			default:
				$msg = JText::_('DV_ADM_CONFIG_SAVE'); 
				$this->setRedirect('index.php?option=com_jvideodirect', JText::_('DV_ADM_CONFIG_SAVE'));
				break;
		}
		
		$controller = new jvideodirectController();
		$controller->redirect();

	}	

	function cancel() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect( 'index.php?option=com_jvideodirect', $msg );
	}


}
?>
