<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

class jvideodirectControllerImport extends jvideodirectController
{
	function __construct() {
		parent::__construct();
	}
	
	function cancel() {
		$msg = JText::_( 'DV_ADM_OPERATION_CANCELLED' );
		$this->setRedirect( JRoute::_('index.php?option=com_jvideodirect'), $msg );
	}

	function remoteServerLink() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		$p = null;
		$p->delimiter = JRequest::getVar( 'xldelimiter', 'comma');		
		$p->delete = JRequest::getVar( 'xldelete', null);		
		$p->trial = JRequest::getVar( 'xltrial', null);			
		$csv = JRequest::getVar( 'xlcsvfile', null, 'files', 'array');	
		$xl = 1;
		$rows = array();
		$rows['ftpusername'] = JRequest::getVar( 'ftpusername', null);
		$rows['ftppassword'] = JRequest::getVar( 'ftppassword', null);		
		$config = new JConfig;
		jimport('joomla.client.helper');
		if (($config->ftp_enable == true) && (JClientHelper::setCredentialsFromRequest('ftp') == true)) {
				JClientHelper::setCredentials('ftp',$rows['ftpusername'], $rows['ftppassword']);
		}			
		if ($csv['error'] == 0) {
			$fileExt = strtolower(jFile::getExt (JFile::makeSafe($csv['name'])));			
			if ($fileExt == 'csv') {
				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');		
				$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'csv';
				if (!JFolder::exists($base)) {
					JFolder::create($base);
					JFile::write($base.DS.'index.php', null);
				}
				$name = viewTools::randomcode(8);
				$p->csvfile = $base.DS.$name.'.csv';
				if (JFile::upload($csv['tmp_name'], $p->csvfile)) {			
					$model =& $this->getModel( 'Import' );
					$ret =& $model->xServerLink($p);	
					$log = $ret['log'];
					$totalcol = count($log[0]);
					$totalrow = count($ret['log']);
					$buf = '<style type="text/css">table {border: 1px solid #888;border-collapse: collapse;} tr,td {border: 1px solid #ccc;font-size:0.9em}</style>';
					$buf .= '<div style="font-size:1.5em; color:blue;"> Total Video: <font color="black">'.$ret['total'].'</font> Errors: <font color="black">'.$ret['error'].'</font>';
					$buf .= ($p->trial) ? ' (Trial Run)</div>' : '</div>';
					$buf .= '<table>';		
					$header = true;
					if ($totalrow > 0) {
						for ($i=0;$i<$totalrow;$i++) {
							if ($header == true) {
								$buf .= '<tr>';
								$buf .= '<td>reason</td>';						
								$buf .= '<td>index</td>';								
								foreach ($log[0] as $key => $value){
									if (($key == 'error') || ($key == 'index') || ($key == 'vid_type') || ($key == 'status') || ($key == 'ext') || ($key == 'reason') || ($key == 'vname') || ($key == 'vid') || ($key == 'remark')) {
									} else {
										if ($key == 'vlength') {
											$buf .= '<td>duration</td>';
										} else {
											$buf .= '<td>'.$key.'</td>';
										}									
									}
								}
								$buf .= '</tr>';
								$header = false;
							}
						}
						for ($i=0;$i<$totalrow;$i++) {
							if ($log[$i]['error'] == 1) {
								$buf .= '<tr>';
								$buf .= '<td><font color="red">'.$log[$i]['reason'].'</font></td>';
								$buf .= '<td>'.$log[$i]['index'].'</td>';								
								foreach ($log[$i] as $key => $value){		
									if (($key == 'error') || ($key == 'index') || ($key == 'vid_type') || ($key == 'status') || ($key == 'vname') || ($key == 'vid') || ($key == 'ext') || ($key == 'reason') || ($key == 'remark')) {
									} else {
										$value = ($value) ? $value : '&nbsp';
										$buf .= '<td>'.$value.'</td>';								
									}
								}
								$buf .= '</tr>';
							}
						}
						for ($i=0;$i<$totalrow;$i++) {
							if ($log[$i]['error'] == null) {
								$buf .= '<tr>';
								$ok = ($log[$i]['reason']) ? $log[$i]['reason'] : '<font color="green">ok</font>';
								$buf .= '<td>'.$ok.'</td>';
								$buf .= '<td>'.$log[$i]['index'].'</td>';								
								foreach ($log[$i] as $key => $value){		
									if (($key == 'error') || ($key == 'index') || ($key == 'vid_type') || ($key == 'status') || ($key == 'vname') || ($key == 'vid') || ($key == 'ext') || ($key == 'reason') || ($key == 'remark')) {
									} else {
										$value = ($value) ? $value : '&nbsp';
										$buf .= '<td>'.$value.'</td>';								
									}
								}
								$buf .= '</tr>';
							}
						}						
						$buf .= '</table>';
						if (!JFile::write($base.DS.'report.html', $buf)) {
							JError::raiseWarning( 500, 'JFile cannot write log file.');
						}
					} else {
						$buf = 'csv file is empty';
						if (!JFile::write($base.DS.'report.html', $buf)) {
							JError::raiseWarning( 500, 'JFile cannot write log file.');
						}						
					}
				} else { $msg = 'csv file uploaded cannot be stored. Please check directory permission of '.$base; $msgtype = 'error';	$xl = 2;}
			} else { $msg = 'Please upload a csv file.'; $msgtype = 'error'; $xl = 2;}
		} else { $msg = 'Upload error !'; $msgtype = 'error'; $xl = 2;}	
		$this->setRedirect('index.php?option=com_jvideodirect&view=import&task=remoteServerLink&xl='.$xl, $msg, $msgtype);	
	}

	function remoteServerLink2() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'csv';	
		if (JFolder::exists($base)) {
		$ret = JFolder::delete($base);
			if ($ret) {
				echo '<font color="green">All csv and log files are successfully deleted.</font>';
			} else {
				echo '<font color="red">Csv and log files cannot be deleted. You may need to delete manually. at joomla/jMediaDirect/videos/csv</font>';
			}
		} else {
			echo '<font color="red">No csv or log files exist.</font>';		
		}
	}

	function batchuploadm() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');			
		$p = null;
		$p->delimiter = JRequest::getVar( 'bumdelimiter', 'comma');		
		$p->delete = JRequest::getVar( 'bumdelete', null);		
		$p->trial = JRequest::getVar( 'bumtrial', null);			
		$csv = JRequest::getVar( 'bumcsvfile', null, 'files', 'array');	
		$bum = 1;
		$rows = array();
		$rows['ftpusername'] = JRequest::getVar( 'ftpusername', null);
		$rows['ftppassword'] = JRequest::getVar( 'ftppassword', null);		
		$config = new JConfig;
		jimport('joomla.client.helper');
		if (($config->ftp_enable == true) && (JClientHelper::setCredentialsFromRequest('ftp') == true)) {
				JClientHelper::setCredentials('ftp',$rows['ftpusername'], $rows['ftppassword']);
		}			
		if ($csv['error'] == 0) {
			$fileExt = strtolower(jFile::getExt (JFile::makeSafe($csv['name'])));			
			if ($fileExt == 'csv') {
				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');		
				$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'csv';
				if (!JFolder::exists($base)) {
					JFolder::create($base);
					JFile::write($base.DS.'index.php', null);
				}
				$name = viewTools::randomcode(8);
				$p->csvfile = $base.DS.$name.'.csv';
				if (JFile::upload($csv['tmp_name'], $p->csvfile)) {			
					$model =& $this->getModel( 'Import' );
					$ret =& $model->batchuploadm($p);	
					$log = $ret['log'];
					$totalcol = count($log[0]);
					$totalrow = count($ret['log']);
					$buf = '<style type="text/css">table {border: 1px solid #888;border-collapse: collapse;} tr,td {border: 1px solid #ccc;font-size:0.9em}</style>';
					$buf .= '<div style="font-size:1.5em; color:blue;"> Total Video: <font color="black">'.$ret['total'].'</font> Errors: <font color="black">'.$ret['error'].'</font>';
					$buf .= ($p->trial) ? ' (Trial Run)</div>' : '</div>';
					$buf .= '<table>';		
					$header = true;
					if ($totalrow > 0) {
						for ($i=0;$i<$totalrow;$i++) {
							if ($header == true) {
								$buf .= '<tr>';
								$buf .= '<td>reason</td>';						
								$buf .= '<td>index</td>';								
								foreach ($log[0] as $key => $value){
									if (($key == 'error') || ($key == 'index') || ($key == 'vid_type') || ($key == 'status') || ($key == 'ext') || ($key == 'reason') || ($key == 'vname') || ($key == 'vid')) {
									} else {
										if ($key == 'vlength') {
											$buf .= '<td>duration</td>';
										} else {
											$buf .= '<td>'.$key.'</td>';
										}									
									}
								}
								$buf .= '</tr>';
								$header = false;
							}
						}
						for ($i=0;$i<$totalrow;$i++) {
							if ($log[$i]['error'] == 1) {
								$buf .= '<tr>';
								$buf .= '<td><font color="red">'.$log[$i]['reason'].'</font></td>';
								$buf .= '<td>'.$log[$i]['index'].'</td>';								
								foreach ($log[$i] as $key => $value){		
									if (($key == 'error') || ($key == 'index') || ($key == 'vid_type') || ($key == 'status') || ($key == 'vname') || ($key == 'vid') || ($key == 'ext') || ($key == 'reason')) {
									} else {
										$value = ($value) ? $value : '&nbsp';
										$buf .= '<td>'.$value.'</td>';								
									}
								}
								$buf .= '</tr>';
							}
						}
						for ($i=0;$i<$totalrow;$i++) {
							if ($log[$i]['error'] == null) {
								$buf .= '<tr>';
								$ok = ($log[$i]['reason']) ? $log[$i]['reason'] : '<font color="green">ok</font>';
								$buf .= '<td>'.$ok.'</td>';
								$buf .= '<td>'.$log[$i]['index'].'</td>';								
								foreach ($log[$i] as $key => $value){		
									if (($key == 'error') || ($key == 'index') || ($key == 'vid_type') || ($key == 'status') || ($key == 'vname') || ($key == 'vid') || ($key == 'ext') || ($key == 'reason')) {
									} else {
										$value = ($value) ? $value : '&nbsp';
										$buf .= '<td>'.$value.'</td>';								
									}
								}
								$buf .= '</tr>';
							}
						}						
						$buf .= '</table>';
						if (!JFile::write($base.DS.'report.html', $buf)) {
							JError::raiseWarning( 500, 'JFile cannot write log file.');
						}
					} else {
						$buf = 'csv file is empty';
						if (!JFile::write($base.DS.'report.html', $buf)) {
							JError::raiseWarning( 500, 'JFile cannot write log file.');
						}						
					}
				} else { $msg = 'csv file uploaded cannot be stored. Please check directory permission of '.$base; $msgtype = 'error';	$bum = 2;}
			} else { $msg = 'Please upload a csv file.'; $msgtype = 'error'; $bum = 2;}
		} else { $msg = 'Upload error !'; $msgtype = 'error'; $bum = 2;}	
		$this->setRedirect('index.php?option=com_jvideodirect&view=import&task=batchuploadm&bum='.$bum, $msg, $msgtype);	
	}

	function batchuploadm2() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );		
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		$base = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'csv';	
		if (JFolder::exists($base)) {
		$ret = JFolder::delete($base);
			if ($ret) {
				echo '<font color="green">All csv and log files are successfully deleted.</font>';
			} else {
				echo '<font color="red">Csv and log files cannot be deleted. You may need to delete manually. at joomla/jMediaDirect/videos/csv</font>';
			}
		} else {
			echo '<font color="red">No csv or log files exist.</font>';		
		}
	}

	function batchupload() {
		JRequest::checkToken() or jexit( 'Request Forbidden' );	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');				
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;			
		$p = null;
		$p->path = JRequest::getVar( 'bupath' );
		$p->nvid = JRequest::getVar( 'bunosvideos', 0);
		$p->nuids = JRequest::getVar( 'buusers', 0);
		$p->tags = JRequest::getVar( 'butags' );
		$p->cat = JRequest::getVar( 'bucat' );
		$p->atype = JRequest::getVar( 'buaccesstype' , 1);
		$p->acomments = JRequest::getVar( 'buallow_comments' , 1);
		$p->aratings = JRequest::getVar( 'buallow_ratings' , 1);
		$p->aembed = JRequest::getVar( 'buallow_embedding' , 1);
		$p->delete = JRequest::getVar( 'budelete' , 1 );
		$p->publish = JRequest::getVar( 'bupublish' , 1);
		$p->callback = JRequest::getVar( 'bucallback' );	
		$uids = explode(',',$p->nuids);
		$logicalerror = null;
		if ((count(uids) > 1) && ($p->nvid < 1)) {
			$logicalerror = 1;
			$msg = 'video distribution count is required if more than 1 user to share.';
			JError::raiseWarning( 500, $msg);			
		}
		if (!$p->path) {
			$msg = 'Full path of your videos folder must be filled.';
			JError::raiseWarning( 500, $msg);
		}
		if (!$p->tags) {
			$msg = 'Tags must be filled.';
			JError::raiseWarning( 500, $msg);		
		}
		if ($p->cat == 'select') {
			$msg = 'Category must be chosen.';
			JError::raiseWarning( 500, $msg);		
		}
		if (($p->cat == 'select')||(!$p->tags)||(!$p->path)||($logicalerror)) {
			$this->setRedirect( 'index.php?option=com_jvideodirect&view=import' );
		} else {
			$model =& $this->getModel( 'Import' );
			$ret =& $model->batchupload($p);
			if ($ret->ok) {
				$msg = JText::_('Video files are set successfully. They are now in the queue for conversion.');
				$msgtype = null;
				$transformer = JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'transformer'.DS.'convertIt.php';
				$transformer2 = JURI::ROOT().'components/com_jvideodirect/tools/transformer/convertIt.php';				
				$k = viewTools::createKey(18);
				$cmd_php = $init->pathToPhp.' '.$transformer.' '.$k;
				$cmd_wget = $init->pathToWget.' -q '.$transformer2.'?k='.$k;
				$callcmd = false;
				$callcmd = (strstr($_SERVER['SERVER_SOFTWARE'], 'Win')) ? true : false;
				switch ($init->converterCall) {
					case '1':
					default:
						if ($callcmd == true) {
							$winShell = new COM("WScript.Shell");
							$oExec = $winShell->Run("$cmd_php", 0, false);
						} else {
							@exec ("$cmd_php > /dev/null &");
						}
						break;
					case '2':
						if ($callcmd == true) {
							$winShell = new COM("WScript.Shell");
							$oExec = $winShell->Run("$cmd_wget", 0, false);
						} else {
							@exec ("$cmd_wget > /dev/null &");
						}
						break;
				}											
			}
			$this->setRedirect('index.php?option=com_jvideodirect&view=import&task=batchupload', $msg, $msgtype);		
		}
	}
}
?>
