<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();


jimport('joomla.application.component.model');

class jvideodirectModelGroups extends JModel
{
	function __construct(){
		parent::__construct();
		global $mainframe, $option;
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'g'.'filter_order', 'filter_order','date',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'g'.'filter_order_Dir',	'filter_order_Dir',	'DESC',	'word' );		
		$limit	= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);		
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);	
		if ($cid) {	
			$this->_id = $cid[0];	
		}
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = "SELECT * FROM #__dv_ugroups ";
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}

	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function getData() {
		if (empty($this->_data)) {
			$query = "SELECT c.*, count(i.gid) AS videocount, u.username FROM #__dv_ugroups AS c LEFT JOIN #__dv_ugroupsitems AS i ON (c.id = i.gid) , #__users AS u WHERE u.id = c.uid GROUP BY c.id ORDER BY `". $this->getState('filter_order') ."` ". $this->getState('filter_order_Dir');
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}	

	function getOrder() {
		$lists['order_Dir'] = $this->getState('filter_order_Dir');
		$lists['order'] = $this->getState('filter_order');
		return $lists;
	}

	function saveCData($data, $table, $id=0) {
		$row =& JTable::getInstance($table, 'Table');		
		if (!$id == 0) {
			$row->load($id);
			}
		
		if (!$row->bind($data)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}		
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		return true;
	}

	function status($cid = array(), $status = 1) {	
		if (count( $cid )) {
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
			$init = new initjVideoDirect;			
			$date = '';
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$data = ($status == 1) ? 'active' : 'suspended';
			$query = 'UPDATE #__dv_ugroups'
				. ' SET status = "'.$data.'" WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			
			//onplugins group after suspend group						
			if ($init->communitySys == 1) {
				$row =& JTable::getInstance('dv_ugroups', 'Table');
				$row->load($cids[0]);
				require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
				$tp = new thirdparties;					
				if ($init->js_userpoint == 1) { 
					$code = ($status == 1) ? '722' : '721';
					$tp->givePoint($code, $row->uid);
				}
			}				
		}
		return true;
	}

	function feature($cid = array(), $feature = 1) {	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');
		$init = new initjVideoDirect;		
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__dv_ugroups'
				. ' SET featured = '.(int) $feature
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			//onplugins group after feature / unfeature a group		
				if ($init->communitySys == 1) {
				$row =& JTable::getInstance('dv_ugroups', 'Table');
				$row->load($cids[0]);
				require_once(JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'thirdparties.php');
				$tp = new thirdparties;					
				if ($init->js_userpoint == 1) { 
					$code = ($feature == 1) ? '724' : '723';
					$tp->givePoint($code, $row->uid);
				}
				$jsas->p = true;$jsas->vid = $row->id;$jsas->name = viewTools::trimStr($row->group, 6);
				$choice = ($feature == 1) ? $init->js_as_group_feature : $init->js_as_group_unfeature;
				$code = ($feature == 1) ? '724' : '723';				
				if (($choice == 1)&&($row->access_type)) { $tp->stream($code,$row->uid,$jsas);}								
			}				
		}
		return true;
	}

	
}
?>
