<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();


jimport('joomla.application.component.model');

class jvideodirectModelImport extends JModel
{
	function __construct(){
		parent::__construct();
		
	}

	function getCategories() {
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');		
		$cats = array();
		$categories=viewTools::getCategoriesTool('id,name'); 
		$cats[] = JHTML::_('select.option', 'select', JText::_( 'DV_F_CATEGORYCHOOSE' ) );
		foreach ($categories as $category) {
			$cats[] = JHTML::_('select.option',  $category->id, JText::_( $category->name ) );
		}
		return $cats;
	}

	function xServerLink($p) {	
		$db =& $this->getDBO(); 
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');			
		switch($p->delimiter) {
			case 'comma': $p->delimiter = ","; break;
			case 'pipe': $p->delimiter = "|"; break;
			case 'tab': $p->delimiter = "	"; break;			
		}
		$csvFile = @fopen($p->csvfile, 'rb');
		@flock($csvFile, LOCK_EX);
			$csvdata = array();
			$csvLength = (phpversion() >= '5' ? 0 : 8000);
			$j = 0;
			while ($row = @fgetcsv($csvFile, $csvLength, $p->delimiter)) {
				if($row !== false) {
					$csvdata[$j] = $row;
					$j++;
				}
			}
		@flock($csvFile, LOCK_UN);
		@fclose($csvFile);
		$totalrow = count($csvdata);
		$ret['log']['key'] = $csvdata[0];
		$csv = array();
		$totalcol = count($csvdata[0]);
		for ($i=1;$i<$totalrow;$i++) {
			for ($j=0;$j<$totalcol;$j++) {
				$key = $csvdata[0][$j];
				$csv[$i-1][$key] = $csvdata[$i][$j];
			}
		}
		$adminid = $this->getuserid('admin');	
		$totalv = count($csv);
		$ret = array();
		if ($totalv > 0) {
			$error = 0;
			for($i=0,$j=1;$i<$totalv;$i++,$j++) {		
				if ( ($csv[$i]['title']) && ($csv[$i]['catid']) && ($csv[$i]['fullpath_imagefile']) && (($csv[$i]['urlpath_sd']) || ($csv[$i]['urlpath_hd'])) ) {
					$csv[$i]['error'] = false;
					$csv[$i]['index'] = $j;
					$csv[$i]['userid'] = ($csv[$i]['userid']) ? $csv[$i]['userid'] : $adminid;
					$csv[$i]['title'] = ($csv[$i]['title']) ? viewTools::cleantext($csv[$i]['title'],false) : null;
					$csv[$i]['description'] = ($csv[$i]['description']) ? viewTools::cleantext($csv[$i]['description'],false) : null;
					$csv[$i]['tags'] = ($csv[$i]['tags']) ? viewTools::cleantext($csv[$i]['tags'],false) : null;
					$csv[$i]['tags'] = implode(', ', explode('*', $csv[$i]['tags']));						
				//	$csv[$i]['fullpath_imagefile'] = JFile::makeSafe($csv[$i]['fullpath_imagefile']);	
					$len = explode(':', $csv[$i]['duration']);
					if ($len[2]) {
						$sec = $len[0] * 3600 + $len[1] * 60 + $len[2];
					} elseif ($len[1]) {
						$sec = $len[0] * 60 + $len[1];
					} else {
						$sec = $len[0];			
					}		
					$csv[$i]['vlength'] = $this->sec2hms($sec);
					$csv[$i]['location_recorded'] = ($csv[$i]['location_recorded']) ? viewTools::cleantext($csv[$i]['location_recorded'],false) : null;
					$csv[$i]['vid_type'] = 'r';
					$csv[$i]['hd'] = ($csv[$i]['urlpath_hd']) ? 1 : 0;
					$csv[$i]['status'] = 'done';
					$createdate =& JFactory::getDate(time());
					$csv[$i]['dateadded'] = $createdate->toFormat();
					$csv[$i]['vname'] = helperTools::createVName();
					$csv[$i]['vid']	= helperTools::createVId();
					$csv[$i]['ext'] = null;
					$db->setQuery('SELECT * FROM #__users WHERE id="'.$csv[$i]['userid'].'"');
					$u = $db->loadObject();		
					if (count($u) == null) {
						$csv[$i]['error'] = true;
						$csv[$i]['reason'] = 'Invalid User ID';						
					}
					$db->setQuery('SELECT * FROM #__dv_categories WHERE id="'.$csv[$i]['catid'].'"');
					$cat = $db->loadObject();		
					if (count($cat) == null) {
						$csv[$i]['error'] = true;
						$csv[$i]['reason'] = 'Invalid Category ID';						
					}					
					$sdfile = $csv[$i]['urlpath_sd'];
					$hdfile = $csv[$i]['urlpath_hd'];		
					$imagefile = $csv[$i]['fullpath_imagefile'];
					if (!JFile::exists($imagefile)) {
						$csv[$i]['error'] = true;
						$csv[$i]['reason'] = 'Image file not exist';
					} else {
						$imgext = strtolower(JFile::getExt($imagefile));				
						if ((!$imgext == 'gif') || (!$imgext == 'jpg') || (!$imgext == 'jpeg') || (!$imgext == 'png')) {
							$csv[$i]['error'] = true;
							$csv[$i]['reason'] = 'Image format unsupport';				
						}
					}
				} else {
					$csv[$i]['error'] = true;
					$csv[$i]['reason'] = 'Insufficient data';
				}
				$error = ($csv[$i]['error'] == true) ? $error++ : $error;
			}	
					
			if ($p->trial == false) {
				$success = 0;
				$error = 0;
				for($i=0;$i<$totalv;$i++) {			
					if ($csv[$i]['error'] == false) {		
						$imagefile = $csv[$i]['fullpath_imagefile'];
						$sdfile = $csv[$i]['urlpath_sd'];
						$hdfile = $csv[$i]['urlpath_hd'];		
						$return = viewTools::makeNewThumbNailm($csv[$i]['userid'], $csv[$i]['vid'], $imagefile);
						if ($return['ok'] == true) {
							if ($p->delete == true) { JFile::delete($imagefile); }
							$p->userid = $csv[$i]['userid'];

							if (($sdfile) && ($hdfile)) {
								$csv[$i]['remark'] = $sdfile.'|^|'.$hdfile;
							} elseif ($sdfile) {
								$csv[$i]['remark'] = $sdfile;					
							} elseif ($hdfile) {
								$csv[$i]['remark'] = $hdfile;	
							}
							if ($this->saveVData($csv[$i])) { 
								if ($this->channelmgnt($csv[$i]['userid'], $csv[$i]['vid'])) {
									$success++; 
								} else {
									$csv[$i]['error'] = true;
									$csv[$i]['reason'] = 'Cannot modify channel. check existence of user id.';
									$error++;											
								}
							} else { 
								$csv[$i]['error'] = true;
								$csv[$i]['reason'] = 'Video data cannot be saved to DB.';
								$error++;										
							}							
						} else {
							$csv[$i]['error'] = true;
							$csv[$i]['reason'] = 'Thumbnail images cannot be generated.';
							$error++;
						}
					} else { // else skip
						$error++;
					}
				}	
				$ret['result'] = true;
				$ret['error'] = $error;
				$ret['success'] = $success;
				$ret['total'] = $totalv;	
				$ret['log'] = $csv;				
			} else {
				$ret['result'] = true;
				$ret['error'] = $error;
				$ret['success'] = null;
				$ret['total'] = $totalv;
				$ret['log'] = $csv;
			}
		} else {
			$ret['result'] = false;
			$ret['reason'] = 'No data in the csv file.';
		}
		
		return $ret;
	}

	function batchuploadm($p) {	
		$db =& $this->getDBO(); 
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'components'.DS.'com_jvideodirect'.DS.'classes'.DS.'tools.php');			
		switch($p->delimiter) {
			case 'comma': $p->delimiter = ","; break;
			case 'pipe': $p->delimiter = "|"; break;
			case 'tab': $p->delimiter = "	"; break;			
		}
		$csvFile = @fopen($p->csvfile, 'rb');
		@flock($csvFile, LOCK_EX);
			$csvdata = array();
			$csvLength = (phpversion() >= '5' ? 0 : 8000);
			$j = 0;
			while ($row = @fgetcsv($csvFile, $csvLength, $p->delimiter)) {
				if($row !== false) {
					$csvdata[$j] = $row;
					$j++;
				}
			}
		@flock($csvFile, LOCK_UN);
		@fclose($csvFile);
		$totalrow = count($csvdata);
		$ret['log']['key'] = $csvdata[0];
		$csv = array();
		$totalcol = count($csvdata[0]);
		for ($i=1;$i<$totalrow;$i++) {
			for ($j=0;$j<$totalcol;$j++) {
				$key = $csvdata[0][$j];
				$csv[$i-1][$key] = $csvdata[$i][$j];
			}
		}
		$adminid = $this->getuserid('admin');	
		$totalv = count($csv);
		$ret = array();
		if ($totalv > 0) {
			$error = 0;
			for($i=0,$j=1;$i<$totalv;$i++,$j++) {		
				if (($csv[$i]['title']) && ($csv[$i]['catid']) && ($csv[$i]['filepath']) && ($csv[$i]['imagefile']) && (($csv[$i]['sdfile']) || ($csv[$i]['hdfile'])) ) {
					$csv[$i]['error'] = false;
					$csv[$i]['index'] = $j;
					$csv[$i]['userid'] = ($csv[$i]['userid']) ? $csv[$i]['userid'] : $adminid;
					$csv[$i]['title'] = ($csv[$i]['title']) ? viewTools::cleantext($csv[$i]['title'],false) : null;
					$csv[$i]['description'] = ($csv[$i]['description']) ? viewTools::cleantext($csv[$i]['description'],false) : null;
					$csv[$i]['tags'] = ($csv[$i]['tags']) ? viewTools::cleantext($csv[$i]['tags'],false) : null;
					$csv[$i]['tags'] = implode(', ', explode('*', $csv[$i]['tags']));
					$csv[$i]['filepath'] = JFolder::makeSafe($csv[$i]['filepath']); 						
					$csv[$i]['imagefile'] = JFile::makeSafe($csv[$i]['imagefile']);
					$csv[$i]['sdfile'] = ($csv[$i]['sdfile']) ? JFile::makeSafe($csv[$i]['sdfile']) : null;
					$csv[$i]['hdfile'] = ($csv[$i]['hdfile']) ? JFile::makeSafe($csv[$i]['hdfile']) : null;	
					$len = explode(':', $csv[$i]['duration']);
					if ($len[2]) {
						$sec = $len[0] * 3600 + $len[1] * 60 + $len[2];
					} elseif ($len[1]) {
						$sec = $len[0] * 60 + $len[1];
					} else {
						$sec = $len[0];			
					}		
					$csv[$i]['vlength'] = $this->sec2hms($sec);
					$csv[$i]['location_recorded'] = ($csv[$i]['location_recorded']) ? viewTools::cleantext($csv[$i]['location_recorded'],false) : null;
					$csv[$i]['vid_type'] = 'u';
					$csv[$i]['hd'] = ($csv[$i]['hdfile']) ? 1 : 0;
					$csv[$i]['status'] = 'done';
					$createdate =& JFactory::getDate(time());
					$csv[$i]['dateadded'] = $createdate->toFormat();
					$csv[$i]['vname'] = helperTools::createVName();
					$csv[$i]['vid']	= helperTools::createVId();
					$csv[$i]['ext'] = ($csv[$i]['hdfile'] == null) ? JFile::getExt($csv[$i]['sdfile']) :  JFile::getExt($csv[$i]['hdfile']);
					$db->setQuery('SELECT * FROM #__users WHERE id="'.$csv[$i]['userid'].'"');
					$u = $db->loadObject();		
					if (count($u) == null) {
						$csv[$i]['error'] = true;
						$csv[$i]['reason'] = 'Invalid User ID';						
					}
					$db->setQuery('SELECT * FROM #__dv_categories WHERE id="'.$csv[$i]['catid'].'"');
					$cat = $db->loadObject();		
					if (count($cat) == null) {
						$csv[$i]['error'] = true;
						$csv[$i]['reason'] = 'Invalid Category ID';						
					}					
					$imagefile = $csv[$i]['filepath'].DS.$csv[$i]['imagefile'];
					$sdfile = $csv[$i]['filepath'].DS.$csv[$i]['sdfile'];
					$hdfile = $csv[$i]['filepath'].DS.$csv[$i]['hdfile'];				
					if (!JFile::exists($imagefile)) {
						$csv[$i]['error'] = true;
						$csv[$i]['reason'] = 'Image file not exist';
					} else {
						$imgext = strtolower(JFile::getExt($imagefile));				
						if ((!$imgext == 'gif') || (!$imgext == 'jpg') || (!$imgext == 'jpeg') || (!$imgext == 'png')) {
							$csv[$i]['error'] = true;
							$csv[$i]['reason'] = 'Image format unsupport';				
						}
					}
					if ($csv[$i]['hdfile']){
						if (JFile::exists($hdfile)) {
							$ext = JFile::getExt($hdfile);
							if (($ext != 'mp4') && ($ext != 'flv')) {
								$csv[$i]['error'] = true;
								$csv[$i]['reason'] = 'HD video must be in mp4 or flv format.';								
							}
						} else {
							$csv[$i]['error'] = true;
							$csv[$i]['reason'] = 'HD video file cannot be found (check path or filename)';	
						}
					}					
					if ($csv[$i]['sdfile']){
						if (JFile::exists($sdfile)) {
							$ext = JFile::getExt($sdfile);
							if ($ext != 'flv') {
								$csv[$i]['error'] = true;
								$csv[$i]['reason'] = 'SD video must be in flv format.';	
							}
						} else {
							$csv[$i]['error'] = true;
							$csv[$i]['reason'] = 'SD video file cannot be found (check path or filename)';						
						}
					}
				} else {
					$csv[$i]['error'] = true;
					$csv[$i]['reason'] = 'Insufficient data';
				}
				$error = ($csv[$i]['error'] == true) ? $error++ : $error;
			}	
					
			if ($p->trial == false) {
				$success = 0;
				$error = 0;
				for($i=0;$i<$totalv;$i++) {			
					if ($csv[$i]['error'] == false) {		
						$imagefile = $csv[$i]['filepath'].DS.$csv[$i]['imagefile'];
						$sdfile = $csv[$i]['filepath'].DS.$csv[$i]['sdfile'];
						$hdfile = $csv[$i]['filepath'].DS.$csv[$i]['hdfile'];						
						$return = viewTools::makeNewThumbNailm($csv[$i]['userid'], $csv[$i]['vid'], $imagefile);
						if ($return['ok'] == true) {
							if ($p->delete == true) { JFile::delete($imagefile); }
							$p->userid = $csv[$i]['userid'];
							$sdflag = $hdflag = 0;
							if ($csv[$i]['sdfile']) {
								$p->vid_ext = $csv[$i]['vid'].'.'.strtolower(JFile::getExt($sdfile));
								$retSD = $this->storeFile($sdfile, $p, 'sd'); 
							}
							if ($csv[$i]['hdfile']) {
								$p->vid_ext = $csv[$i]['vid'].'.'.strtolower(JFile::getExt($hdfile));
								$retHD = $this->storeFile($hdfile, $p, 'hd'); 
							}
							if (($csv[$i]['sdfile']) && ($csv[$i]['hdfile'])) {
								if (($retSD == true) && ($retHD == true)) {
									if ($this->saveVData($csv[$i])) { 
										if ($this->channelmgnt($csv[$i]['userid'], $csv[$i]['vid'])) {
											$success++; 
										} else {
											$csv[$i]['error'] = true;
											$csv[$i]['reason'] = 'Cannot modify channel. check existence of user id.';
											$error++;											
										}
									} else { 
										$csv[$i]['error'] = true;
										$csv[$i]['reason'] = 'Video data cannot be saved to DB.';
										$error++;										
									}
								} else {
									$csv[$i]['error'] = true;
									$csv[$i]['reason'] = 'Video transfer error.';
									$error++;								
								}
							} elseif ($csv[$i]['sdfile']) {
								if ($retSD == true) {
								if ($this->saveVData($csv[$i])) { 
										if ($this->channelmgnt($csv[$i]['userid'], $csv[$i]['vid'])) {
											$success++; 
										} else {
											$csv[$i]['error'] = true;
											$csv[$i]['reason'] = 'Cannot modify channel. check existence of user id.';
											$error++;											
										}
									} else { 
										$csv[$i]['error'] = true;
										$csv[$i]['reason'] = 'Video data cannot be saved to DB.';
										$error++;										
									}
								} else {
									$csv[$i]['error'] = true;
									$csv[$i]['reason'] = 'Video transfer error.';
									$error++;								
								}							
							} elseif ($csv[$i]['hdfile']) {
								if ($retHD == true) {
								if ($this->saveVData($csv[$i])) { 
										if ($this->channelmgnt($csv[$i]['userid'], $csv[$i]['vid'])) {
											$success++; 
										} else {
											$csv[$i]['error'] = true;
											$csv[$i]['reason'] = 'Cannot modify channel. check existence of user id.';
											$error++;											
										}
									} else { 
										$csv[$i]['error'] = true;
										$csv[$i]['reason'] = 'Video data cannot be saved to DB.';
										$error++;										
									}
								} else {
									$csv[$i]['error'] = true;
									$csv[$i]['reason'] = 'Video transfer error.';
									$error++;								
								}		
							}						
						} else {
							$csv[$i]['error'] = true;
							$csv[$i]['reason'] = 'Thumbnail images cannot be generated.';
							$error++;
						}
					} else { // else skip
						$error++;
					}
				}	
				$ret['result'] = true;
				$ret['error'] = $error;
				$ret['success'] = $success;
				$ret['total'] = $totalv;	
				$ret['log'] = $csv;				
			} else {
				$ret['result'] = true;
				$ret['error'] = $error;
				$ret['success'] = null;
				$ret['total'] = $totalv;
				$ret['log'] = $csv;
			}
		} else {
			$ret['result'] = false;
			$ret['reason'] = 'No data in the csv file.';
		}
		return $ret;
	}
	
	function batchupload($p) {		
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;
		$files = JFolder::files($p->path, null);
		$tfiles = count($files);
		$uids = explode(',',$p->nuids);
		if ((count($uids) == 1) && ($uids[0] == 0)){
			$uids[0] = $this->getuserid('admin');
		}
		if ($tfiles > 0) {
			$ret->ok = false;
			for ($i=0,$j=0,$v=0;$i<$tfiles;$i++) {
				$file = $p->path.DS.$files[$i];
				if ($this->uploadedFileCheck( $file )) {
					$db =& $this->getDBO(); 
					$s->vid = viewTools::randomcode(32);
					$s->ext = JFile::getExt($file);					
					$data->userid = $uids[$j];
					$data->vid_ext = $s->vid.'.'.$s->ext;
					$data->delete = $p->delete;
					$info = $this->videoInfo($file, $init);
					if ($this->storeFile($file, $data)) {
						$s->userid = $uids[$j];
						$s->vid_type = 'u';
						$s->vname = viewTools::randomcode(13);
						if (isset($info['ID_CLIP_INFO_NAME0'])) {
							$s->title = (($info['ID_CLIP_INFO_NAME0'] == 'name') && ($info['ID_CLIP_INFO_VALUE0'])) ? $db->getEscaped(viewTools::cleantext($info['ID_CLIP_INFO_VALUE0'])) : $db->getEscaped(viewTools::cleantext($p->callback));
						} else {
							$s->title = $db->getEscaped(viewTools::cleantext($p->callback));
						}
						if (isset($info['ID_CLIP_INFO_NAME1'])) {
							$s->description = (($info['ID_CLIP_INFO_NAME1'] == 'description') && ($info['ID_CLIP_INFO_VALUE1'])) ? $db->getEscaped(viewTools::cleantext($info['ID_CLIP_INFO_VALUE1'])) : $db->getEscaped(viewTools::cleantext($p->callback));	
						} else {
							$s->description = $db->getEscaped(viewTools::cleantext($p->callback));
						}
						$s->status = 'queue';
						$createdate =& JFactory::getDate(time());
						$s->dateadded = $createdate->toFormat();
						$s->published = $p->publish;
						$s->tags = $db->getEscaped(viewTools::cleantext($p->tags));
						$s->catid = $p->cat;
						$s->accesstype = $p->atype; 
						$s->allow_comments = $p->acomments;
						$s->allow_embedding = $p->aembed;
						$s->allow_ratings = $p->aratings;
						$row =& JTable::getInstance('dv_videos', 'Table');		
						if ($row->bind($s)) {
							if ($row->store()) {
								$v = $v + 1; 
								if (($p->nvid > 0) && ($p->nvid == $v)) { $j = ($j == count($uids) - 1) ? 0 : $j + 1; $v = 0;}
								$this->channelmgnt($s->userid, $s->vid);					
								$ret->ok = true;
							} else { JError::raiseWarning( 500, 'Cannot store to Database');}		
						} 		
					}
				}
			}
		} else { JError::raiseWarning( 500, 'The folder is empty.');}	
		return $ret;
	}

	function saveVData($obj) {
		$row =& JTable::getInstance('dv_videos', 'Table');		
		if ($row->bind($obj)) {
			if ($row->store()) {			
				$ret = true;
			} else { $ret = false;}		
		} 		
		return $ret;
	}
	
	function storeFile($tmpFile, $data, $type = null) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');
		$base = JPATH_ROOT.DS.'jMediaDirect';
		$this->dir_structure($data->userid);
		switch($type) {
			case 'sd':
				$distFile = $base.DS.'videos'.DS.'sd'.DS.$data->userid.DS.$data->vid_ext;
			break;
			case 'hd':
				$distFile = $base.DS.'videos'.DS.'hd'.DS.$data->userid.DS.$data->vid_ext.'.flv';
			break;
			default:
				$distFile = $base.DS.'videos'.DS.'org'.DS.$data->userid.DS.$data->vid_ext;
			break;			
		}
		if ($data->delete) {
			$ret = JFile::move($tmpFile, $distFile);
		} else {
			$ret = JFile::copy($tmpFile, $distFile);
		}
		return $ret;
	}

	function dir_structure($uid) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');
		$base = JPATH_ROOT.DS.'jMediaDirect';
		$dir_structure = array( 0 => $base,
								 	 $base.DS.'buffer',
									 $base.DS.'videos',
									 $base.DS.'videos'.DS.'tester',	
									 $base.DS.'videos'.DS.'tester'.DS.'test',
									 $base.DS.'videos'.DS.'temp',
									 $base.DS.'videos'.DS.'pics',
									 $base.DS.'videos'.DS.'pics'.DS.'small',
									 $base.DS.'videos'.DS.'pics'.DS.'medium',
									 $base.DS.'videos'.DS.'pics'.DS.'small2',
									 $base.DS.'videos'.DS.'org',
									 $base.DS.'videos'.DS.'hd',
									 $base.DS.'videos'.DS.'sd',
									 $base.DS.'videos'.DS.'csv',
									 $base.DS.'videos'.DS.'org'.DS.$uid,
									 $base.DS.'videos'.DS.'hd'.DS.$uid,
									 $base.DS.'videos'.DS.'sd'.DS.$uid);
									
									
		for ($i=0;$i<count($dir_structure);$i++) {
			if (!JFolder::exists($dir_structure[$i])) {
				JFolder::create($dir_structure[$i]);
			}
			if (JFolder::exists($dir_structure[$i])) {
				if (!JFile::exists($dir_structure[$i].DS.'index.html')) {
					JFile::write($dir_structure[$i].DS.'index.html', null);			
				}
			}
		}		
	}

	function videoInfo($file, $init, $item=false) {
		$go = false;
		$encodePriority = $init->encodePriority;
		if ($encodePriority == 1) {
			if ($init->pathToFfmpeg == null) {
				if (!$init->pathToMplayer == null) { $encodePriority == 2; $go = true; }
			} else { $go = true; }
		} else {
			if ($init->pathToMplayer == null) {
				if (!$init->pathToFfmpeg == null) { $encodePriority == 1; $go = true; }
			} else { $go = true; }		
		}
		
		if ($go == true) {
			$flag = false; $ex = null;
			if (file_exists($file)) {
				$flag = true;
			} elseif (file_exists($file.'.flv')) {
				$flag = true;
				$ex = '.flv';
			}
			if ($flag == true) {
				
				switch ($encodePriority) {
					case '1':
						$cmd = $init->pathToFfmpeg.' -i '.$file.$ex;
						@exec($cmd.' 2>&1', $buf);
						$arr = array();
						for ($i=0;$i<count($buf);$i++) {
							if (preg_match('/Duration:.(.*?),.start/', $buf[$i], $match)) {	
								$len = explode(':', $match[1]);
								$hr = 0; $min = 0;
								if ($len[0] > 0) { $hr = $len[0] * 3600; }
								if ($len[1] > 0) { $min = $len[1] * 60; }
								$arr['ID_LENGTH'] = $hr + $min + $len[2];				
							}
							if (preg_match('/Stream.*Video:/', $buf[$i])) {
								if (preg_match('/[0-9]?[0-9][0-9][0-9]x[0-9][0-9][0-9][0-9]?/', $buf[$i], $match)) {							
									$len = explode('x', $match[0]);
									$arr['ID_VIDEO_WIDTH'] = $len[0];
									$arr['ID_VIDEO_HEIGHT'] = $len[1];
									if ($len[0] > $len[1]) {
										$arr['ID_VIDEO_ASPECT'] = $len[0] / $len[1];
									} else { $arr['ID_VIDEO_ASPECT'] = 0; }
								}		
							}
							if (preg_match('/from.\'(.*?)\':/', $buf[$i], $match)) {	
								$arr['ID_FILENAME'] = $match[1];
							}						
						}						
					break;
					case '2':
						$cmd = $init->pathToMplayer.' '.$file.$ex. ' -msglevel all=-1 -vo null -ao null -identify -frames 1';	
						@exec($cmd.' 2>&1', $buf);		
						$arr = array();
						for ($i=0;$i<count($buf);$i++) {
							$tmp = @explode('=',$buf[$i]);
							$key = $tmp[0];
							if (strstr($key, 'ID_')) {$arr[$key] = $tmp[1];}
						}					
					break;
					case '3':
						$arr = false;
					break;
				}
			}
		}
			
		if (!$item) return $arr;
		else return $arr[$item];
	}
	
	function uploadedFileCheck( $file ) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;
		$allowExt = explode(', ', $init->extGe);
			
		$result = true;
		if (JFile::exists($file)) {
			if (!in_array(strtolower(JFile::getExt($file)), $allowExt)) {
				$msg = strtolower(JFile::getName($file).' '.JText::_('DV_UP_ERR_3'));
				JError::raiseWarning( 500, $msg , error);
				$result = false; }
		} else {
			$msg = JFile::getName($file).' '.JText::_('DV_UP_ERR_1');
			JError::raiseWarning( 500, $msg, error);
			$result = false;
		}		
		return $result;		
	}	

	function channelmgnt($cuid, $cvid) {	
		$db =& $this->getDBO(); 
		$db->setQuery('SELECT * FROM #__users WHERE id="'.$cuid.'"');
		$u = $db->loadObject();		
		$createdate =& JFactory::getDate(time());
		$db->setQuery('SELECT * FROM #__dv_uchannels WHERE uid="'.$u->id.'" AND channel="'.$u->username.'"');
		$row = $db->loadObject();
		if (!isset($row->id)) {
			$p = null;
			$p->uid = $u->id;
			$p->channel = $u->username;
			$p->access_type = '1';
			$p->image = '0';
			$p->subscribers = '0';
			$p->date = $createdate->toFormat();
			$p->remark = 'default';
			$p->status = 'active';
			$p->acount = '0';
			$ch =& JTable::getInstance('dv_uchannels', 'Table');		
			if ($ch->bind($p)) {
				if ($ch->store()) {			
					$ret = true;
				} else { $ret = false;}		
			} 			
			if ($ret == true) {
				$db->setQuery('SELECT * FROM #__dv_uchannels WHERE uid="'.$u->id.'" AND channel="'.$u->username.'"');
				$row = $db->loadObject();			
			}		
		}
		$db->setQuery('SELECT * FROM #__dv_videos WHERE vid="'.$cvid.'"');
		$v = $db->loadObject();							
		$p = null;
		$p->uid = $u->id;
		$p->cid = $row->id;
		$p->vid = $v->id;
		$p->ordering = '0';
		$p->date = $createdate->toFormat();
		$ch =& JTable::getInstance('dv_uchannelsitems', 'Table');			
		if ($ch->bind($p)) {
			if ($ch->store()) {			
				$ret = true;
			} else { $ret = false;}		
		} 	
		return $ret;		
	}
	
	function getuserid($username) {
		$db =& $this->getDBO(); 	
		$db->setQuery("SELECT * FROM #__users WHERE username = '".$username."'");
		$user = $db->loadObject();
		return $user->id;	
	}
	
	function sec2hms($sec, $useColon = true) {
		$hms = "";
		$hours = intval(intval($sec) / 3600);
		if ($hours > 0){
			$hms .= ($useColon) ? str_pad($hours, 2, "0", STR_PAD_LEFT). ':' : $hours;
		}elseif ($useColon){
			// $hms .= '00:';
		}
		$minutes = intval(($sec / 60) % 60);
		if ($minutes > 0) {
			$hms .= ($useColon) ? str_pad($minutes, 2, "0", STR_PAD_LEFT). ':' : $minutes;
		} else { $hms .= '00:';}
		$seconds = intval($sec % 60);
		$hms .= ($useColon) ? str_pad($seconds, 2, "0", STR_PAD_LEFT) : $seconds;
		return $hms;
	}	
}
?>
