<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class jvideodirectViewCategory extends JView
{
	function display($tpl = null) {
		$task = JRequest::getVar( 'task', '' );
			
		switch($task) {
			case 'editCat':
				$this->editCategory();
			break;
			
			default:
				$this->generalCat();
			break;
		}		
		parent::display($tpl);
	}

	function generalCat() {
		global $mainframe;
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;

		$config = new JConfig;
		if ($config->ftp_enable == false) {
			if (!is_writable(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php')) {
				JError::raiseWarning( 500, JText::_('DV_ADM_CONFIG_LOCKED'));}
		}
		$doc =& JFactory::getDocument();
		$doc->addStyleSheet( JURI::base().'components/com_jvideodirect/css/main.css' );
		JToolBarHelper::title( JText::_( 'jVideoDirect - Categories' ), 'category' );
		JToolBarHelper::deleteList(JText::_('DV_ADM_CAT_DELCFM'),'deleteCat', JText::_( 'Delete' ));
		JToolBarHelper::cancel('cancel');
		viewTools::subMenu('category');

		$items		= & $this->get( 'Data');
		$total		= & $this->get( 'Total');
		$order		= & $this->get( 'Order' );		
		$pagination = & $this->get( 'Pagination' );

		$catDis='';
		for ( $i=0, $n=count( $items ); $i < $n; $i++ ) {
			$cat = &$items[$i];
			$link = 'index.php?option=com_jvideodirect&view=category&task=editCat&format=raw&cid[]='. $cat->id;
			$catimage = ($cat->image) ? JURI::ROOT().'jMediaDirect/videos/pics/categories/'.$cat->image.'.png' : JURI::ROOT().'components/com_jvideodirect/themes/'.$init->theme.'/images/noImageCat.png';
			$published 	= JHTML::_('grid.published', $cat, $i );
			$featured 	= viewTools::featured($cat, $i);
			$catDis .= '<tr class="row'.$i.'">';
			$catDis .= '<td align="center">'.$pagination->getRowOffset( $i ).'</td>';
			$catDis .= '<td align="center">'.JHTML::_('grid.id', $i, $cat->id ).'</td>';
			$catDis .= '<td align="center"><img src="'.$catimage.'" style="max-width:30px;max-height:30px"/></td>';
			$catDis .= '<td><a href="'.$link.'" class="modal" rel="{size: {x: 400, y: 400}}">'.$cat->name.'</a></td>';
			$catDis .= '<td><a href="'.$link.'" class="modal" rel="{size: {x: 400, y: 400}}">'.$cat->description.'</a></td>';
			$catDis .= '<td>'.$cat->tags.'</td>';	
			$catDis .= '<td align="center">'.$published.'</td>';
			$catDis .= '<td align="center">'.$featured.'</td>';
		//	$catDis .= '<td align="center">'.$cat->editor.'</td>';
			$catDis .= '<td class="order"><span>'. $pagination->orderUpIcon( $i, true, 'orderup', 'Move Up', 1 ).'</span><span>'.$pagination->orderDownIcon( $i, $n, true, 'orderdown', 'Move Down', 1 ).'</span><input type="text" name="order[]" size="3" value="'. $cat->ordering.'" class="text_area" style="text-align: center" /></td>';
				
		//	$catDis .= '<td align="center">'.$cat->groups.'</td>';
		//	$catDis .= '<td align="center">'.$cat->accesstype.'</td>';
			$catDis .= '<td align="center">'.$cat->date_added.'</td>';
			$catDis .= '<td align="center">'.$cat->id.'</td>';
			$catDis .= '</tr>';
		}
		
		
		$this->assignref( 'pagination', $pagination );
		$this->assignref( 'orderSave', JHTML::_('grid.order',  $items ));
		$this->assignref( 'totalcat', count($items) );
		$this->assignref( 'categories', $catDis );	
		$this->assignref( 'lists', $order );
		$this->assignref( 'fc', viewTools::fc());
	}
	
	function editCategory( ) {
		$config = new JConfig;
		if ($config->ftp_enable == false) {
			if (!is_writable(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php')) {
				JError::raiseWarning( 500, JText::_('DV_ADM_CONFIG_LOCKED'));}
		}
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		$doc =& JFactory::getDocument();
		$doc->addStyleSheet( JURI::base().'components/com_jvideodirect/css/main.css' );		
		JToolBarHelper::title( JText::_( 'jVideoDirect - Categories' ), 'category' );
		viewTools::subMenu('category');	
	
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		$row =& JTable::getInstance('dv_categories', 'Table');
		$id = $cid[0];
		$row->load($cid[0]);
		$catimage = ($row->image) ? JURI::ROOT().'jMediaDirect/videos/pics/categories/'.$row->image.'.png' : JURI::ROOT().'components/com_jvideodirect/themes/'.$init->theme.'/images/noImageCat.png';
		$imagelink = '<img src="'.$catimage.'" style="max-width:100px;max-height:100px"/>';
		$this->assignref( 'catimage', $imagelink );
		$this->assignref( 'id', $id );
		$this->assignref( 'row', $row );	
	}
	
}
