<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class jvideodirectViewChannels extends JView
{
	function display($tpl = null) {
		$task = JRequest::getVar( 'task', '' );
		switch($task) {
			default:
				$this->showChannels();
			break;	
		}		
		parent::display($tpl);		
	}

	function showChannels() {
		global $mainframe;
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;
		
		$doc =& JFactory::getDocument();
		$doc->addStyleSheet( JURI::base().'components/com_jvideodirect/css/main.css' );
		$js = 'window.addEvent(\'domready\', function(){
			var Tips1 = new Tips($$(\'.videoinfo\'));
		}); ';
		$doc->addScriptDeclaration($js);

		$config = new JConfig;
		if ($config->ftp_enable == false) {
			if (!is_writable(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php')) {
				JError::raiseWarning( 500, JText::_('DV_ADM_CONFIG_LOCKED'));}
		}

		JToolBarHelper::title( JText::_( 'jVideoDirect - Channels Management' ), 'channels' );
		JToolBarHelper::deleteList(JText::_('DV_ADM_CAT_DELCFM'),'deletechannel', JText::_( 'Delete' ));
		JToolBarHelper::cancel('cancel');
		viewTools::subMenu('channels');

		$items		= & $this->get( 'Data');
		$total		= & $this->get( 'Total');
		$order		= & $this->get( 'Order' );
		$pagination = & $this->get( 'Pagination' );	
	
		$ch='';
		for ( $i=0, $n=count( $items ); $i < $n; $i++ ) {
			$row = &$items[$i];
			
			$log = ($row->status == 'active') ? '' : ' style="text-decoration:line-through;" ';
			$log1 = ($row->status == 'active') ? '' : ' <span class="videoinfo" title="<b>'.JText::_('Reason to suspend').'</b>::'.viewtools::cleantext($row->reason).'"> ';
			$log2 = ($row->status == 'active') ? '' : ' </span> ';			
			$subscribers = ($row->subscribers) ? '<a href="index.php?option=com_jvideodirect&task=getsubscribers&format=raw&t=1&id='. $row->id.'" class="modal" rel="{size: {x: 200, y: 250}}">'.$row->subscribers.'</a>':$row->subscribers;	
			if ($row->videocount) {
				$link = 'index.php?option=com_jvideodirect&view=videomanagement&t=1&id='. $row->id;
				$name = '<a href="'.$link.'"'.$log.'>'.viewTools::trimStr(viewtools::cleantext($row->channel), 40).'</a>';
				$videocount = '<a href="'.$link.'"'.$log.'>'.$row->videocount.'</a>';
			} else { 
				$link = '#'; 
				$name = viewTools::trimStr(viewtools::cleantext($row->channel), 40);
				$videocount = $row->videocount;}
			$featured 	= viewTools::featured($row, $i);	
			$status = ($row->remark == 'default') ? '<span class="videoinfo" title="default channel"><img src="'.JURI::ROOT().'administrator/components/com_jvideodirect/images/tick.png"/></span>' : viewTools::status($row, $i, 1);
			$access = ($row->access_type) ? '<font color="green">'.JText::_('DV_F_PUBLIC').'</font>' : '<font color="red">'.JText::_('DV_F_PRIVATE').'</font>';
			$ch .= '<tr class="row'.$i.'">';
			$ch .= '<td align="center">'.$pagination->getRowOffset( $i ).'</td>';
			$ch .= '<td align="center">'.JHTML::_('grid.id', $i, $row->id ).'</td>';
			$ch .= '<td>';		
			$image = (!$row->image) ? '<img src="'.JURI::ROOT().'administrator/components/com_jvideodirect/images/noimage.png" width ="60px"/>' : '<img src="'.JURI::ROOT().'jMediaDirect/videos/pics/channels/'.$row->uid.'/'.$row->image.'.png" width ="65px"/>';
			$ch .= '<div style="width:65px;margin: 0 auto;">';
			$ch .= '<a href="'.$link.'">'.$image.'</a>';
			$ch .= '</div>';
			$ch .= '</td>';	
			$ch .= '<td align="center">'.$featured.'</td>';		
			$ch .= '<td align="center">'.$status.'</td>';	
			$ch .= '<td align="left"'.$log.'>'.$log1.$row->unique.$log2.'</td>';				
			$ch .= '<td align="left"'.$log.'>'.$log1.$name.$log2.'</td>';
			$ch .= '<td align="left"'.$log.'><span class="videoinfo" title="<u>'.viewtools::cleantext($row->channel).'</u>::<b>'.JText::_('Description').'</b><br/>'.viewtools::cleantext($row->description).'<br/>">'.viewTools::trimStr(viewtools::cleantext($row->description), 40).'</span></td>';	
			$ch .= '<td align="left"'.$log.'>'.$log1.$row->tags.$log2.'</td>';			
			$ch .= '<td align="center"'.$log.'>'.$log1.$videocount.$log2.'</td>';				
			$ch .= '<td align="center"'.$log.'>'.$log1.$subscribers.$log2.'</td>';	
			$ch .= '<td align="center"'.$log.'>'.$log1.$access.$log2.'</td>';			
			$date =& JFactory::getDate($row->date);
			$ch .= '<td align="center"'.$log.'>'.$log1.$date->toFormat(JTEXT::_('DATE_FORMAT_JVD')).$log2.'</td>';	
			$ch .= '<td align="center"'.$log.'><span class="videoinfo" title="'.$row->username.'">'.$row->uid.'</span></td>';				
			$ch .= '<td align="center"'.$log.'>'.$log1.$row->id.$log2.'</td>';
			$ch .= '</tr>';
			
		}
		
		$this->assignref( 'pagination', $pagination );
		$this->assignref( 'total', count($items) );
		$this->assignref( 'channels', $ch );	
		$this->assignref( 'lists', $order );
		$this->assignref( 'fc', viewTools::fc());		
	}
}
