<?php
/**
 * @package		jVideoDirect components, modules, plugins for Joomla
 * @subpackage
 * @copyright	Copyright (C) 2010 jVideoDirect.com. All rights reserved.
 * @contact 	cs@jvideodirect.com
 * @license		GPLv3 http://www.gnu.org/licenses/gpl.html
 * jVideoDirect is free software. This version may have been modified pursuant to the
 * GPLv3, and as distributed it includes or is derivative
 * of works licensed under the GPLv3 or other free or open
 * source software licenses. 
 */
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class jvideodirectViewVideomanagement extends JView
{
	function display($tpl = null) {
		$task = JRequest::getVar( 'task', '' );
		$layout = JRequest::getVar( 'layout', '' );		
		if ($layout == 'batchupdate') {$task = 'batchupdate';}
		switch($task) {
			default:	
				if (JRequest::getVar( 'r' ) == 1) {
					$session =& JFactory::getSession();
					$session->clear('t', 'jvideodirect');
					$session->clear('id', 'jvideodirect');		
				}
				$this->showVideo();				
			break;	
			case 'batchupdate':
				$this->batchupdate();
			break;
		}		
		parent::display($tpl);		
	}

	function batchupdate() {
		$session =& JFactory::getSession();
		$cids = $session->get('bucid');		
		if ($cids) {
			$session->clear('bucid');
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');			
			$init = new initjVideoDirect;
			$doc =& JFactory::getDocument();
			$doc->addStyleSheet( JURI::base().'components/com_jvideodirect/css/main.css' );
			$js = "function checkCB() {
						if (
						document.adminForm.bu_feature.checked == false &&
						document.adminForm.bu_approval.checked == false &&
						document.adminForm.bu_checked.checked == false &&	
						document.adminForm.bu_access.checked == false &&	
						document.adminForm.bu_category.checked == false &&	
						document.adminForm.bu_totalviews.checked == false &&	
						document.adminForm.bu_totalvotes.checked == false &&	
						document.adminForm.bu_totalratings.checked == false &&	
						document.adminForm.bu_allow_comments.checked == false &&	
						document.adminForm.bu_allow_embedding.checked == false &&	
						document.adminForm.bu_allow_ratings.checked == false) 
						{
							alert ('Please make a selection from the action list to batch update');
							return false;
						} else {
							return true;
						}
					}";
			$doc->addScriptDeclaration($js);
			$model =& $this->getModel('videomanagement');				
			viewTools::subMenu('videomanagement');			
			JToolBarHelper::title( JText::_( 'jVideoDirect - Videos Management' ), 'videomanagement' );		
			JToolBarHelper::cancel('cancelbu');
			$cats = array();
			$categories=viewTools::getCategoriesTool('id,name'); 
			foreach ($categories as $category) {
				$cats[] = JHTML::_('select.option',  $category->id, JText::_( $category->name ) );
			}	
			$se = & $model->getselectedvideo($cids);
			$si = '<h3>Selected Video(s)</h3>';
			$totalselected = count($se);
			$header = '<tr style="background-color:#ddd;"><th style="padding:0 2px;">Index</th><th style="padding:0 2px;">Video ID</th><th>Image</th><th style="padding:0 2px;">Title</th></tr>';
			$si .= '<div style="float:left;border:1px solid #aaa;padding:10px 10px;">';		
			$si .= '<table>';
			$si .= $header;
			for($i=0,$j=0;$i<$totalselected;$i++,$j++) {
				if ($j==10) { $si .= '</table></div><div style="float:left;border:1px solid #aaa;padding:10px 10px;"><table>'.$header;$j=0;}
			$si .= '<tr>';
			$offset = $i + 1;
			$si .= '<td style="border-bottom:1px solid #ccc;">'. $offset .'</td>';	
			$si .= '<td style="border-bottom:1px solid #ccc;">'. $se[$i]->id .'</td>';
			$si .= '<td style="border-bottom:1px solid #ccc;"><img src="'.JURI::ROOT().'jMediaDirect/videos/pics/small/'.$se[$i]->vid.'.jpg" width ="55px"/></td>';
			$si .= '<td style="border-bottom:1px solid #ccc;">'.viewTools::trimStr($se[$i]->title, '20').'</td>';
			$si .= '</tr>';
			}
			$si .= '</table>';			
			$si .= '</div>';			
			$this->assignref( 'selecteditems', $si);
			$this->assignref( 'cats', $cats);			
			$this->assignref( 'cids', $cids);
			$this->assignref( 'fc', viewTools::fc());				
		} else {
			$controller = new  jvideodirectController();
			$controller->setRedirect('index.php?option=com_jvideodirect&view=videomanagement');
			$controller->redirect();					
		}
	}

	function showVideo() {
		global $mainframe;
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');		
		$t = JRequest::getVar( 't', '' );
		$id = JRequest::getVar( 'id', '' );	
		
		if (!$t) {
			$session =& JFactory::getSession();
			$t = $session->get('t', '', 'jvideodirect');
			$id = $session->get('id', '', 'jvideodirect');		
		}
	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'tools'.DS.'views.php');	
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php');	
		$init = new initjVideoDirect;
		
		$doc =& JFactory::getDocument();
		$doc->addStyleSheet( JURI::base().'components/com_jvideodirect/css/main.css' );
		$js = 'window.addEvent(\'domready\', function(){
			var Tips1 = new Tips($$(\'.videoinfo\'));
		}); ';
		$doc->addScriptDeclaration($js);
		
		$config = new JConfig;
		if ($config->ftp_enable == false) {
			if (!is_writable(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jvideodirect'.DS.'init.jvideodirect.php')) {
				JError::raiseWarning( 500, JText::_('DV_ADM_CONFIG_LOCKED'));}
		}

		if ($t) {		
			$items     	= & $this->get('DataType');
			$total		= & $this->get( 'TotalType');	
			$type['t']	= $t;
			$type['id']	= $id;
			if ($t == 1) {
				viewTools::subMenu('channels');
				JToolBarHelper::title( JText::_( 'jVideoDirect - Channel’s Videos' ), 'channels' );
			} else {
				viewTools::subMenu('groups');
				JToolBarHelper::title( JText::_( 'jVideoDirect - Group’s Videos' ), 'groups' );		
			}
			if ($id) {
				$type['name'] = & $this->get('Typename');	
			}
			$taskstats = '';
		} else {
			viewTools::subMenu('videomanagement');		
			$items		= & $this->get( 'Data');
			$total		= & $this->get( 'Total');	
			JToolBarHelper::title( JText::_( 'jVideoDirect - Videos Management' ), 'videomanagement' );		
			$taskstats = $this->get('Taskstats');
		}
		JToolBarHelper::editList('batchupdateform', JText::_( 'DV_ADM_CAT_BATCHUPDATE' ));
		JToolBarHelper::deleteList(JText::_('DV_ADM_CAT_DELCFM'),'deleteVideo', JText::_( 'Delete' ));
		JToolBarHelper::cancel('cancel');

		$order		= & $this->get( 'Order' );
		$pagination = & $this->get( 'Pagination' );	
		$ra = ($order['order'] == 'totalabuse') ? 1 : 0;
	
		$vidDis = null; $vdo = null;
		for ( $i=0, $n=count( $items ); $i < $n; $i++ ) {
			$vdo = &$items[$i];		
			$vdo->title = viewTools::cleantext($vdo->title);
			$r = '';
			$statimg = 'stats.png';
			if ($ra) {
				switch($vdo->totalabuse) {
					case '0': $statimg = 'stats.png';break;
					case '1': $statimg = 'stats1.png';break;
					case '2': $statimg = 'stats2.png';break;
					default: $statimg = 'stats3.png';break;					
				}	
	   			$model =& $this->getModel('videomanagement');			
				$r = & $model->getreporters($vdo->id);          		
			}			
			$log = ($vdo->log == 1) ? ' style="text-decoration:line-through;" ' : '';
			
			$link = 'index.php?option=com_jvideodirect&task=editVideo&format=raw&cid[]='. $vdo->id;
			$vdolinkSD = 'index.php?option=com_jvideodirect&task=playVideo&v='.$vdo->vname.'&format=raw&hd=0';
			$vdolinkHD = 'index.php?option=com_jvideodirect&task=playVideo&v='.$vdo->vname.'&format=raw&hd=1';
			$isHD = (($vdo->hd=='1') || ($vdo->hd=='2')) ? 1 : 0;
			$featured 	= viewTools::featured($vdo, $i);			
			$approval 	= viewTools::approval($vdo, $i);
			$checked 	= viewTools::checked($vdo, $i);			
			$quality = (($vdo->hd=='1') || ($vdo->hd=='2')) ? JText::_('YES') : JText::_('NO');
			$accesstype = ($vdo->accesstype == 1) ? JText::_('DV_F_PUBLIC') : '<font color="red">'.JText::_('DV_F_PRIVATE').'</font>';			
			$vidDis .= '<tr class="row'.$i.'">';
			$vidDis .= '<td align="center">'.$pagination->getRowOffset( $i ).'</td>';
			$vidDis .= '<td align="center">'.JHTML::_('grid.id', $i, $vdo->id ).'</td>';
			$vidDis .= '<td>';		
			$vidDis .= '<div style="width:80px;">';
			$vidDis .= '<div style="width:25px;float:left;">';			
			$sd_w = $vdo->sd_w + 23;$sd_h = $vdo->sd_h + 23;$hd_w = $vdo->hd_w + 23;$hd_h = $vdo->hd_h + 23;
			$rating = 0;
			if ($vdo->totalratings && $vdo->totalvotes)
			$rating = round($vdo->totalratings / $vdo->totalvotes );	
			$sdfile = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'sd'.DS.$vdo->userid.DS.$vdo->vid.'.flv';
			$hdfile = JPATH_ROOT.DS.'jMediaDirect'.DS.'videos'.DS.'hd'.DS.$vdo->userid.DS.$vdo->vid.'.mp4';			
			if ((($init->availQuality != '1') || (JFile::exists($sdfile)) || ($vdo->vid_type == 'e')) && ($vdo->status == 'done')) {
			$sdplayerW = 426;
			$hdplayerW = 426;

			if (($vdo->hd_h > 0) && ($vdo->hd_w > 0)) {
				if ($vdo->hd_h > $vdo->hd_w ) {
					$hdplayerW = 240;
				}
			}			
	
			if (($vdo->sd_h > 0) && ($vdo->sd_w > 0)) {
				if ($vdo->sd_h > $vdo->sd_w ) {
					$sdplayerW = 240;
				}
			}
			
			if (($vdo->sd_h > 0) || ($vdo->sd_w > 0)) {
				$sdplayerH = round(($vdo->sd_h / $vdo->sd_w) * $sdplayerW) + 23;
			} else { $sdplayerH = 240 + 23; }
			$sdplayerW = $sdplayerW + 23;			
			$vidDis .= '<div class="sd_icon">
							<a href="'.$vdolinkSD.'" title="'.JText::_('DV_P_CP_APLAY').'-SD" class="modal"  rel="{handler: \'iframe\', size: {x: '.$sdplayerW.', y: '.$sdplayerH.'}}" onclick="blur();"><span></span></a>
						</div>';	
			}
			if (($isHD || (JFile::exists($hdfile)) || (JFile::exists($hdfile.'flv'))) && ($vdo->status == 'done')) {
			if (($vdo->hd_h > 0) || ($vdo->hd_w > 0)) {
				$hdplayerH = round(($vdo->hd_h / $vdo->hd_w) * $hdplayerW) + 23;
			} else { $hdplayerH = 240 + 23; }
			$hdplayerW = $hdplayerW + 23;
			$vidDis .= '<div class="hd_icon">
							<a href="'.$vdolinkHD.'" title="'.JText::_('DV_P_CP_APLAY').'-HD" class="modal"  rel="{handler: \'iframe\', size: {x: '.$hdplayerW.', y: '.$hdplayerH.'}}" onclick="blur();"><span></span></a>
						</div>';				
			}
			$vidDis .= '</div><div style="width:55px;float:left">';
			$vidDis .= '<a href="'.$link.'" class="modal" rel="{size: {x: 520, y: 540}}"><img src="'.JURI::ROOT().'jMediaDirect/videos/pics/small/'.$vdo->vid.'.jpg" width ="55px""/></a>';
			$vidDis .= '</div></div>';
			$vidDis .= '</td>';			
			$vidDis .= '<td align="center">'.$featured.'</td>';		
			$vidDis .= '<td align="center">'.$approval.'</td>';	
			$vidDis .= '<td align="center">'.$checked.'</td>';				
		//	$vidDis .= '<td align="center">'.$editor.'</td>';
			if ($vdo->vid_type == 'g') {				
				$embedinfo = '<b>Source:</b><br/>'.$vdo->remark.'<br>';
			} elseif ($vdo->vid_type == 'e') {
				$ems = explode('|^|', $vdo->remark);
				$embedinfo = (isset($ems[2])) ? '<b>Embed from:</b><br/>'.$ems[2].'<br>' : null;
			} else {
				$embedinfo = null;
			}		
			$vidDis .= '<td align="left"><span class="videoinfo" title="<u>'.viewtools::cleantext($vdo->title).'</u>::<b>'.JText::_('Description').'</b><br/>'.viewtools::cleantext($vdo->description).'<br/><br/><b>'.JText::_('Tags').'</b><br/>'.viewTools::tagstool($vdo->tags).'<br/><br/><b>'.JText::_('Location Recorded') .'</b><br/>'.viewtools::cleantext($vdo->loc_record).'<br/><br/><b>Video Name:</b> '.$vdo->vname.'<br/><b>Video ID:</b><br/>'.$vdo->vid.'<br>'.$embedinfo.'">
			<a href="'.$link.'" class="modal" rel="{size: {x: 520, y: 540}}" '.$log.'>'.viewtools::cleantext($vdo->title).'</a></span></td>';
			$vidDis .= '<td align="center"'.$log.'>'.$vdo->catname.'</td>';	
			$vidDis .= '<td align="center"'.$log.'>'.$vdo->vlength.'</td>';	
			$vidDis .= '<td align="center"><span class="videoinfo" title="'.viewtools::cleantext($vdo->title).'::<p/>'.JText::_('Views').': '.number_format($vdo->totalviews, 0,'', ',').'<br/>'.JText::_('Votes').': '.number_format($vdo->totalvotes, 0,'', ',').'<br/>'.JText::_('Rating').': '.$rating.'<br/>'.JText::_('Comments').': '.number_format($vdo->totalcomments, 0,'', ',').'<br/>'.JText::_('Favorites').': '.number_format($vdo->totalfavorites, 0,'', ',').'<br/>'.JText::_('Playlist added').': '.number_format($vdo->totalplaylist, 0,'', ',').'<br/>'.JText::_('Abuse Reported').': '.number_format($vdo->totalabuse, 0,'', ',').'<br/>'.$r.'"><img src="'.JURI::ROOT().'administrator/components/com_jvideodirect/images/'.$statimg.'"/></span></td>';
			// JText::_('Shared').': '.$vdo->totalshared.'<br/>'.			
			$vidDis .= '<td align="center"'.$log.'>'.$quality.'</td>';
			$vidDis .= '<td align="center"'.$log.'>'.$accesstype.'</td>';
			$vidDis .= '<td align="center"'.$log.'>'.$vdo->status.'</td>';		
			$date =& JFactory::getDate($vdo->dateadded);
			$vidDis .= '<td align="center"'.$log.'>'.$date->toFormat(JTEXT::_('DATE_FORMAT_JVD')).'</td>';
			if ($vdo->checkeddate != 0) {
				$date =& JFactory::getDate($vdo->checkeddate);		
				$checkedDate = $date->toFormat(JTEXT::_('DATE_FORMAT_JVD'));
			} else {
				$checkedDate = JTEXT::_('n/a');
			}
			$vidDis .= '<td align="center"'.$log.'>'.$checkedDate.'</td>';	
			$vidDis .= '<td align="center">'.$vdo->id.'</td>';
			$vidDis .= '</tr>';
		}
		
		$this->assignref( 'pagination', $pagination );
		$this->assignref( 'totalvids', count($items) );
		$this->assignref( 'videos', $vidDis );	
		$this->assignref( 'lists', $order );
		$this->assignref( 'type',$type);
		$this->assignref( 'taskstats',$taskstats);
		$this->assignref( 'fc', viewTools::fc());		
	}

}
